/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.savagehomeautomation.devoxx;

import java.net.UnknownHostException;
import org.eclipse.paho.client.mqttv3.IMqttActionListener;
import org.eclipse.paho.client.mqttv3.IMqttToken;
import org.eclipse.paho.client.mqttv3.MqttAsyncClient;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

/**
 * @author Robert Savage 
 * @see http://www.pi4j.com 
 * @see http://www.savagehomeautomation.com
 * @see https://twitter.com/savageautomate
 * 
 * This class is a helper class for working with MQTT client
 */
public class MqttHelper {
    
    // ---------------------------------------------------------------------------
    // MQTT CONFIG
    // ---------------------------------------------------------------------------
    public static final String BROKER = "tcp://192.168.0.1:1883";
    //public static final String BROKER = "tcp://iot.eclipse.org:1883";
    public static final String TOPIC  = "pi4j/devoxx/example";
    public static final int QOS       = 0;
    
    public static MqttAsyncClient createAsync() throws MqttException, UnknownHostException{
        // create & return client instance
        return new MqttAsyncClient(BROKER, 
                MqttClient.generateClientId(), 
                new MemoryPersistence());
    }

    public static MqttClient create() throws MqttException, UnknownHostException{
        // create & return client instance
        return new MqttClient(BROKER, 
                MqttClient.generateClientId(), 
                new MemoryPersistence());
    }
    
    public static MqttConnectOptions getConnectOptions(){
        MqttConnectOptions connOpts = new MqttConnectOptions();
        connOpts.setCleanSession(true);        
        return connOpts;
    }
    
    public static void connect(MqttClient client) throws MqttException{
        client.connect(getConnectOptions());
        System.out.println("[MQTT] +++ (CONNECTED) " + client.getClientId() + "@" + BROKER);
    }

    public static void connect(MqttAsyncClient client, IMqttActionListener listener) throws MqttException{
        client.connect(getConnectOptions(), null, new IMqttActionListener() {

            @Override
            public void onSuccess(IMqttToken asyncActionToken) {
                System.out.println("[MQTT] +++ (CONNECTED) " + client.getClientId() + "@" + BROKER);
                listener.onSuccess(asyncActionToken);
            }

            @Override
            public void onFailure(IMqttToken asyncActionToken, Throwable exception) {
                System.out.println("[MQTT] --- (CONNECTION FAILED) " + client.getClientId() + "@" + BROKER);
                exception.printStackTrace();
                listener.onFailure(asyncActionToken, exception);
            }
        });
    }
}
